//+------------------------------------------------------------------+
//|                                                       Test_A.mq4 |
//|                      Copyright  2008, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"
extern double Lots         = 0.01; //   
extern int    TakeProfit   = 45;
extern int    StopLoss     = 1000;
extern int    DistanceOrd  = 28;  //     
extern bool   AllLimitOrders = True;   //    
extern int    Mn           = 15062008; // 
extern int    TrailingStep  = 3;       //  
extern int    Slippage     = 3;   //  
int    TrailingLimitB;//       //   
int    TrailingLimitS;
color  clOpenBuy     = LightBlue;    //   BuyStop
color  clOpenSell    = LightCoral;   //   SellStop
bool   UseSound      = True;         //   
string NameFileSound = "expert.wav"; //   

//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
 double  ldTake=0, pAsk, pBid, ldStop;
TrailingLimitB = DistanceOrd;
TrailingLimitS = DistanceOrd;
//----    ---------------------------+
  
  for (int i=0; i<OrdersTotal(); i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if (AllLimitOrders || OrderSymbol()==Symbol()) {
        TrailingOrders();
      }
    }
  }
if(!ExistOrders("",OP_SELLLIMIT,Mn,0))
  {       
  
      pBid=Bid+DistanceOrd*Point;                         
      ldTake=pBid-TakeProfit*Point; 
      ldStop=pBid+StopLoss*Point;
      SetOrder("", OP_SELLLIMIT, Lots, pBid, ldStop, ldTake, Mn, 0);
  } 
//+-----------------------------------------------------+  
//----
   return(0);
  }
//+------------------------------------------------------------------+
//+----------------------------------------------------------------------------+
//|   :  .      .        |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    sy -     (NULL  "" -  )          |
//|    op -                                                            |
//|    ll -                                                                 |
//|    pp -                                                                |
//|    sl -                                                         |
//|    tp -                                                         |
//|    mn - Magic Number                                                       |
//|    ex -                                                       |
//+----------------------------------------------------------------------------+
int SetOrder(string sy, int op, double ll, double pp, double sl=0,
             double tp=0, int mn=0, datetime ex=0) 
{ 
 //Comment("Ask=",Ask," Bid=",Bid," tp=",tp,"pp=",pp);
  color clOpen;
  int   err, ticket; 
  if (sy=="" || sy=="0") sy=Symbol();
  if (op==OP_BUYLIMIT || op==OP_BUYSTOP) clOpen=clOpenBuy; else clOpen=clOpenSell;
  ticket=OrderSend(sy, op, ll, pp, Slippage, sl, tp, "", mn, ex, clOpen);
  if (ticket<0) 
   {
  //  Comment(" OrdersTotal()=",OrdersTotal()," isCloseLastPosTip=",isCloseLastPosTip("", -1,-1),
 //" PriceOpenLastClosePos=",PriceOpenLastClosePos("", -1, -1)," tp=",tp);
    err=GetLastError();
    Print("Error=",err," tip=",op," =",pp," Ask=",Ask," Bid=",Bid," tp=",tp," mn=",mn);
    //Print("Error(",err,") set ",GetNameOP(op),": ",ErrorDescription(err));
    //Print("Ask=",Ask," Bid=",Bid," sy=",sy," ll=",ll,
         // " pp=",pp," sl=",sl," tp=",tp," mn=",mn);
   return(-1);      
    }
    if(ticket>=0)
     {
      return(1);
     } 
}
//+----------------------------------------------------------------------------+
//+------------------------------------------------------------------+
//|                                 |
//+------------------------------------------------------------------+
void TrailingOrders() {
  double pBid, pAsk, pp;

  pp=Point;//MarketInfo(OrderSymbol(), MODE_POINT);
  if (OrderType()==OP_BUYLIMIT) 
  {
    pAsk=Ask;//MarketInfo(OrderSymbol(), MODE_ASK);
    if (pAsk-OrderOpenPrice()>(TrailingLimitB+TrailingStep-1)*pp) 
    { 
     ModifyOpenPrice(NormalizeDouble(pAsk-TrailingLimitB*pp,Digits), 0);   
    }
  }
  if (OrderType()==OP_SELLLIMIT) 
  {
    pBid=Bid;//MarketInfo(OrderSymbol(), MODE_BID);
    if (OrderOpenPrice()-pBid>(TrailingLimitS+TrailingStep-1)*pp) 
    {
      ModifyOpenPrice(NormalizeDouble(pBid+TrailingLimitS*pp,Digits), 0);
    }
  }
}

//+------------------------------------------------------------------+
//|                                                     |
//| :                                                       |
//|   ldOpen  -  OpenPrice                                    |
//|   lcColor -                                       |
//+------------------------------------------------------------------+
void ModifyOpenPrice(double ldOpen, color lcColor=CLR_NONE) {
  bool   fm;
  double ldStop=OrderStopLoss();
  double ldTake=OrderTakeProfit();
  fm=OrderModify(OrderTicket(), ldOpen, ldStop, ldTake, 0, 0);
  if (fm && UseSound) PlaySound(NameFileSound);
  else Print("ldOpen=",ldOpen," ldStop=",ldStop," ldTake=",ldTake," ticket=",OrderTicket());
}
//+------------------------------------------------------------------+
//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 12.03.2008                                                     |
//|   :    .                         |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    sy -     (""   -  ,                   |
//|                                     NULL -  )                 |
//|    op -                    (-1   -  )                    |
//|    mn - MagicNumber                (-1   -  )                    |
//|    ot -               ( 0   -   )          |
//+----------------------------------------------------------------------------+
bool ExistOrders(string sy="", int op=-1, int mn=-1, datetime ot=0) {
  int i, k=OrdersTotal(), ty;
 
  if (sy=="0") sy=Symbol();
  for (i=0; i<k; i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      ty=OrderType();
      if (ty>1 && ty<6) {
        if ((OrderSymbol()==sy || sy=="") && (op<0 || ty==op)) {
          if (mn<0 || OrderMagicNumber()==mn) {
            if (ot<=OrderOpenTime()) return(True);
          }
        }
      }
    }
  }
  return(False);
}